LAI:Load()

function HUDManager:remove_if_no_valid(reload, low_ammo, no_ammo)
	if not reload and not low_ammo and not no_ammo then
		local hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)
		local texts = { hud.panel:child("low_ammo_vfx"), hud.panel:child("total_low_ammo_vfx"), hud.panel:child("no_ammo_vfx") }
		local blurs = { hud.panel:child("blur_low_ammo"), hud.panel:child("blur_total_low_ammo"), hud.panel:child("blur_no_ammo") }

		for _, text_ in pairs(texts) do
			if text_ then
				text_:set_visible(false)
				text_:set_alpha(0)
			end
		end

		for _, blur_ in pairs(blurs) do
			if blur_ then
				blur_:set_visible(false)
			end
		end
	end
end

local data = LAI._data
local scale = data.LAI_scale
local texture_path = { total_low_ammo = "low_ammo_indicator", low_ammo = "reload_indicator",  no_ammo = "no_ammo_indicator" }

local function do_Rainbow()
	local t = Application:time()
	local r,g,b = 1,1,1
	local h = (t % 5) / 5 * 6
	local i = math.floor(h)
	local f = h - i
	local q = 1 - f

	if i % 6 == 0 then
		r, g, b = 1, f, 0
	elseif i % 6 == 1 then
		r, g, b = q, 1, 0
	elseif i % 6 == 2 then
		r, g, b = 0, 1, f
	elseif i % 6 == 3 then
		r, g, b = 0, q, 1
	elseif i % 6 == 4 then
		r, g, b = f, 0, 1
	elseif i % 6 == 5 then
		r, g, b = 1, 0, q
	end

	return Color(r,g,b)
end

function HUDManager:_set_vfxs(enable_vfx, disable_vfx)
    local hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)
    local n = tostring(enable_vfx)
    local d2 = disable_vfx

    local scale_half = 0.5 * scale
    local blur_width = (255 - 26) * scale_half
    local blur_height = (52 - 16) * scale_half

    local blur = hud.panel:bitmap({
        name = "blur_" .. n,
        texture = "guis/textures/test_blur_df",
        render_template = "VertexColorTexturedBlur3D",
        layer = 999,
        w = blur_width,
        h = blur_height,
        visible = false
    })

    self._indi = nil
    local texture_path_n = texture_path[n]
    if texture_path_n then
        self._indi = hud.panel:bitmap({
            name = n .. "_vfx",
            texture = texture_path_n,
            layer = 1000,
            visible = false,
            w = 255 * scale_half,
            h = 52 * scale_half,
            blend_mode = "add",
        })
    end

    if not self._indi then
        return
    end

    local indicator_texture = hud.panel:child(n .. "_vfx") or self._indi
    local blur_effect = hud.panel:child("blur_" .. n) or blur

    for _, d in ipairs(d2) do
        local t = hud.panel:child(d .. "_vfx")
        local b = hud.panel:child("blur_" .. d)
        if t then
            t:set_visible(false)
            t:set_alpha(0)
        end
        if b then
            b:set_visible(false)
        end
    end

    indicator_texture:set_visible(true)
    blur_effect:set_visible(data.LAI_blur_toggle)
    indicator_texture:set_center(hud.panel:w() / 2, hud.panel:h() / 2)
    blur_effect:set_center(hud.panel:w() / 2, hud.panel:h() / 2)
    indicator_texture:set_y(indicator_texture:y() + 20)
    blur_effect:set_y(blur_effect:y() + 20)

    local enabled = true

    local function func2(o, dir)
        while enabled do
            local time = Application:time()
            coroutine.yield()
            if data.LAI_do_rainbow then
                indicator_texture:set_color(do_Rainbow())
            else
                local color_value = math.abs(math.cos(time * 90))
                indicator_texture:set_color(Color(235, color_value, color_value))
            end
            if data.LAI_do_fade_out then
                local alpha_value = math.abs(math.sin(time * 90))
                indicator_texture:set_alpha(alpha_value)
            else
                indicator_texture:set_alpha(1)
            end
        end
        indicator_texture:remove(o)
        indicator_texture:hide()
    end

    indicator_texture:animate(func2)
end
