_G.LAI = _G.LAI or {}
LAI._path = ModPath
LAI._data_path = SavePath .. "LAI_data.txt"
LAI._data = {
	LAI_scale = 0.5,
	LAI_blur_toggle = true,
	LAI_do_rainbow = false,
	LAI_do_fade_out = true
}

function LAI:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self._data ) )
		file:close()
	end
end

function LAI:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	end
end

Hooks:Add("MenuManagerInitialize", "MenuManagerInitializeLAI", function(menu_manager)
	MenuCallbackHandler.LAI_on_scale_change_callback = function(self,item)
		LAI._data.LAI_scale = item:value()
		LAI:Save()
	end
	MenuCallbackHandler.callback_LAI_blur_toggle = function(self,item)
		local value = item:value() == "on"
		LAI._data.LAI_blur_toggle = value
		LAI:Save()
	end
	MenuCallbackHandler.callback_LAI_do_rainbow = function(self,item)
		local value = item:value() == "on"
		LAI._data.LAI_do_rainbow = value
		LAI:Save()
	end
	MenuCallbackHandler.callback_LAI_do_fade_out = function(self,item)
		local value = item:value() == "on"
		LAI._data.LAI_do_fade_out = value
		LAI:Save()
	end
	MenuCallbackHandler.LAI_closed = function(self)
		LAI:Save()
	end
	LAI:Load()
	MenuHelper:LoadFromJsonFile(LAI._path .. "menu/options.txt", LAI, LAI._data)
end)